/* 
 * $Header: /home/projects/mule/scm/mule/samples/hello/src/java/org/mule/samples/hello/StringToNameString.java,v 1.3 2005/10/08 17:27:08 rossmason Exp $
 * $Revision: 1.3 $
 * $Date: 2005/10/08 17:27:08 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
 
package org.mule.samples.hello;

import org.mule.transformers.NoActionTransformer;
import org.mule.transformers.AbstractTransformer;
import org.mule.umo.transformer.TransformerException;

/**
 *  <code>StringToNameString</code> converts from a String to a NameString object
 *
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.3 $
 */
public class StringToNameString extends AbstractTransformer
{
    /**
     * 
     */
    public StringToNameString()
    {
        super();
        this.registerSourceType(String.class);
    }
    

    /* (non-Javadoc)
     * @see org.mule.transformers.AbstractTransformer#doTransform(java.lang.Object)
     */
    public Object doTransform(Object src) throws TransformerException
    {
        String name = (String)src;
        int i = name.indexOf("\r");
        if(i > -1) name = name.substring(0, i);
        return new NameString(name);
    }

}
